unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Memo1: TMemo;
    procedure FormDeactivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    lastcount1, lastcount2:integer;
    lasttime:tdatetime;
    racecount:integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses dateutils;

{$R *.dfm}

procedure TForm1.FormDeactivate(Sender: TObject);
begin
  memo1.lines.add(timetostr(now)+' reactivated');
  SetWindowPos(TForm(sender).Handle,
              HWND_TOPMOST,
              0, 0, 0, 0,
              SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW)
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  timer1.enabled:=false;
  TForm(sender).OnDeactivate:=nil;
  screen.OnActiveFormChange:=nil;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetWindowLong(  handle, GWL_STYLE, WS_OVERLAPPED or
                                     WS_VISIBLE or
                                     WS_POPUP);
  SetWindowLong(  handle, GWL_EXSTYLE, WS_EX_DLGMODALFRAME or
                                       WS_EX_TOPMOST or
                                       WS_EX_TOOLWINDOW);
  WindowState:=wsMaximized;
  Invalidate;
  application.processmessages;
  screen.OnActiveFormChange:=FormDeactivate;// NOTE: this can lead to race condition
  timer1.enabled:=true;
  lasttime:=incminute(now, -1);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var t, o:hwnd;
begin
  // this si to catch any window that does not steal focus (which shows without causing a OnActiveFormChange)
  if (screen.FormCount<>lastcount1) or (screen.CustomFormCount<>lastcount2) then
  begin
    lastcount1:=screen.FormCount;
    lastcount2:=screen.CustomFormCount;
    memo1.lines.add('count missmatch. re-activating');
    FormDeactivate(self);
  end else
    if GetActiveWindow<>handle then
    begin
      memo1.lines.add('active window changed. re-activating');
      FormDeactivate(self);
    end else
    begin// http://support.microsoft.com/kb/126386
      // THIS WILL DEFINETLY GO INTO RACE CONDITION (tested with yahoo email notification)
      if millisecondsbetween(lasttime,now)<2*timer1.interval+5 then
        inc(racecount);
      if racecount>=5 then
      begin
        timer1.enabled:=false;
        memo1.lines.add('**** race detected. timer disabled');
        exit;
      end;
      t:=GetWindow(handle, GW_HWNDFIRST);
      o:=SetActiveWindow(t);
      if (GetActiveWindow<>handle) or (t<>handle) then
      begin
        lasttime:=now;
        memo1.lines.add('topmost window changed. re-activating');
        FormDeactivate(self);
      end;
    end;
end;

end.
